/*
		EditZcmd.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.
		Class to match dialog of the same name.	
*/


#include "stdafx.h"
#include "Cbreak.h"
#include "EditZcmd.h"
#include "MobQuery.h"
#include "ItemQuery.h"
#include "RoomQuery.h"
#include "DirQuery.h"
#include "IntQuery.h"
#include "DstateQuery.h"
#include "PosQuery.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditZcmd dialog


EditZcmd::EditZcmd(int dep, int type, int arg1, int arg2, int arg3,CWnd* pParent /*=NULL*/)
	: CDialog(EditZcmd::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditZcmd)
	m_depend = dep;
	m_type =type;
	//}}AFX_DATA_INIT
	arg[0]=arg1;
	arg[1]=arg2;
	arg[2]=arg3;
}


void EditZcmd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditZcmd)
	DDX_Control(pDX, IDC_ZCMD_ARG3, m_arg3);
	DDX_Control(pDX, IDC_ZCMD_ARG2, m_arg2);
	DDX_Control(pDX, IDC_ZCMD_ARG1, m_arg1);
	DDX_Check(pDX, IDC_DEPEND, m_depend);
	DDX_CBIndex(pDX, IDC_ZCMD_TYPE, m_type);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(EditZcmd, CDialog)
	//{{AFX_MSG_MAP(EditZcmd)
	ON_BN_CLICKED(IDC_ZCMD_ARG1, OnZcmdArg1)
	ON_CBN_SELCHANGE(IDC_ZCMD_TYPE, OnSelchangeZcmdType)
	ON_BN_CLICKED(IDC_ZCMD_ARG2, OnZcmdArg2)
	ON_BN_CLICKED(IDC_ZCMD_ARG3, OnZcmdArg3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditZcmd message handlers



BOOL EditZcmd::OnInitDialog() 
{
	CDialog::OnInitDialog();

	LoadEditZcmd();

	return TRUE;  
}



void EditZcmd::OnOK() 
{

	
	CDialog::OnOK();
}

void EditZcmd::OnZcmdArg1() 
{
	MobQuery mq(arg[0]);
  ItemQuery iq(arg[0]);

	switch(m_type) {
		case ZCMD_MOBILE: 
      mq.DoModal();
			arg[0] = mq.value;
			break;
		case ZCMD_OBJECT:
		case ZCMD_GIVE:
		case ZCMD_EQUIP:
		case ZCMD_PUT:
			iq.DoModal();
			arg[0] = iq.value;
			break;
		default:
			TRACE0("Unknown or inapplicable command type");
			return;
			break;
	}
	UpdateData(FALSE);
}

void EditZcmd::OnSelchangeZcmdType() 
{
  UpdateData(TRUE);
	LoadEditZcmd();
}

extern const char *zcmd_buttons[NUM_OF_ZCMDS][3];

void EditZcmd::LoadEditZcmd()
{
	extern CCbreakApp theApp;

  GetDlgItem(IDC_ZCMD_ARG1)->ShowWindow(SW_HIDE);
  GetDlgItem(IDC_ZCMD_ARG2)->ShowWindow(SW_HIDE);
  GetDlgItem(IDC_ZCMD_ARG3)->ShowWindow(SW_HIDE);


  /* okay. lets show the windows */

	if(_stricmp("*",zcmd_buttons[m_type][0])  && _stricmp("&",zcmd_buttons[m_type][0])) {
		GetDlgItem(IDC_ZCMD_ARG1)->ShowWindow(SW_SHOW);
    m_arg1.SetWindowText(iprintf("%s",zcmd_buttons[m_type][0]));
	}
	if(_stricmp("*",zcmd_buttons[m_type][1])  && _stricmp("&",zcmd_buttons[m_type][1])) {
		GetDlgItem(IDC_ZCMD_ARG2)->ShowWindow(SW_SHOW);
    m_arg2.SetWindowText(iprintf("%s",zcmd_buttons[m_type][1]));
	}
	if(_stricmp("*",zcmd_buttons[m_type][2])  && _stricmp("&",zcmd_buttons[m_type][2])) {
		GetDlgItem(IDC_ZCMD_ARG3)->ShowWindow(SW_SHOW);
    m_arg3.SetWindowText(iprintf("%s",zcmd_buttons[m_type][2]));
	}

	if(_stricmp("&",zcmd_buttons[m_type][0])) {
		arg[0] = theApp.dlg->current_room;
	}
		if(_stricmp("&",zcmd_buttons[m_type][2])) {
		arg[2] = theApp.dlg->current_room;
	}
	UpdateData(FALSE);
}

void EditZcmd::OnZcmdArg2() 
{
  ItemQuery iq(arg[1]);
  IntQuery *intq;
  DirQuery dirq(arg[1]);

	switch(m_type) {
		case ZCMD_MOBILE:
		case ZCMD_OBJECT:
		case ZCMD_GIVE:
		case ZCMD_EQUIP:
		case ZCMD_PUT:
      intq = new IntQuery("Max Existing","Max Existing",arg[1]);
      intq->DoModal();
			arg[1] = intq->value;
			delete intq;
			break;
        case ZCMD_DOOR:
			dirq.DoModal();
			arg[1] = dirq.value;
			break;
		case ZCMD_REMOVE:
			iq.DoModal();
			arg[1] = iq.value;
			break;
		default:
			TRACE0("Unknown or inapplicable command type");
			return;
			break;
	}
	UpdateData(FALSE);	
}

void EditZcmd::OnZcmdArg3() 
{
  ItemQuery iq(arg[2]);
  DstateQuery dq(arg[2]);
	PosQuery	pq(arg[2]);

	switch(m_type) {

		case ZCMD_EQUIP:
			pq.DoModal();
			arg[2]=pq.value;
			break;
		case ZCMD_PUT:
			iq.DoModal();
			arg[2] = iq.value;
			break;
		case ZCMD_DOOR:
			dq.DoModal();
			arg[2]=dq.value;
			break;
		default:
			TRACE0("Unknown or inapplicable command type");
			return;
			break;
	}
	UpdateData(FALSE);	
}

void EditZcmd::OnCancel() 
{
  m_type = -1;
	
	CDialog::OnCancel();
}
